require 'rbconfig'
require 'ruby-progressbar'
#This module contains methods that are not Linux distribution specific
module Confpkgs
  #This module contains methods that are not Linux distribution specific
  module Utils
    #Returns true if current environment is linux, false otherwise
    def is_linux
      @os = RbConfig::CONFIG['host_os']
      return true if @os.downcase.match('linux')
      false
    end
    
    #Returns lowercase name of linux distribution of current environment
    def distro_name
      distro_name = %x(cat /etc/os-release | grep '^ID=')[3..-2]
    end

    #returns a prettier string
    def pretty_print(msg)
      str = ""
      line = Proc.new {str += "+"; msg.size.times {str += "-"}; str+= "+\n"}
      line.call
      str += "|#{msg.capitalize}|\n"
      line.call
      str
    end
  end
end
