module Confpkgs
  class PackageManager
    #Package management operations as constants
    INSTALL_CMD = ""
    REMOVE_CMD = ""

    attr_reader :op_msgs
    
    def initialize
      #Hash for storing package manager output for each pkg operation
      @op_msgs = {}
    end

    def install(array_of_pkgs)
      if self.class::INSTALL_CMD.empty?
        raise Exception, "INSTALL_CMD must be implemented by subclass"
      end
      @op_msgs[:install] = %x(#{self.class::INSTALL_CMD} #{array_of_pkgs.join(' ')})
    end 

    def remove(array_of_pkgs)
      if self.class::REMOVE_CMD.empty?
        raise Exception, "REMOVE_CMD must be implemented by subclass"
      end
      @op_msgs[:remove] = %x(#{self.class::REMOVE_CMD} #{array_of_pkgs.join(' ')})
    end
    
#TODO: not fully implemented yet
=begin
    #add external package repositories
    def add_repos(repo_hash)
      repo_hash.each do |repo, url|
        #ar   - add repo
        #-f   - add autorefresh flag to repo
        #url  - URL of repo
        #repo - alias for repo 
        @op_msgs[:add_repos] = %x(zypper ar -f #{url} #{repo})
      end
    end
=end

  end
end 
